#ifndef parserOpenHRPKineo_H
#define parserOpenHRPKineo_H

/************************

INCLUDE

************************/

#undef PACKAGE_BUGREPORT
#undef PACKAGE_NAME
#undef PACKAGE_STRING
#undef PACKAGE_TARNAME
#undef PACKAGE_VERSION
#include "common-modelloader.hh"

#include "KineoKCDModel/kppKCDPolyhedron.h"

using namespace std ;

/************************

DEFINE

************************/

///Maximal number of triangle for each body of the robot.
#define NUM_MAX_TRI 30000

typedef _CORBA_ObjRef_Element<_objref_ParserModelObject, ParserModelObject_Helper> TopenHrpJoint;  

/**
   \brief Provides utility functions which are used to make Kineo objects from OpenHRP ModelInfo
 */
class CparserOpenHRPKineo {
public:
    /**
       \brief Set colors of polygons
    */
    void setPolyColor(CkppKCDPolyhedronShPtr hppPolyhedron, 
		      const ModelInfo::shortSeq *colorIndexes,  
		      const std::vector < CkppMaterial > materialVector);

    /**
       \brief Get CkitMat4 from OpenHrp position vector and attitude matrix.
    */ 
    void getPositionMatrix(const ValueMatrix *relPos, 
			   const ValueMatrix *relAttitude, 
			   CkitMat4& kwsRelPosMat);

    /**
       \brief Builds hppPolyhedron
     */
    CkppKCDPolyhedronShPtr buildHppPolyhedron(const ModelInfo_ptr inOpenHRPModelInfo,
					      const TopenHrpJoint& openHRPObstModel,
					      const char *inName);
};

#endif
